#
# gSmile - emoticon manager
# 
# Copyright (C) 2005, Federico Pelloni <federico.pelloni@gmail.com>
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#


from gtk.gdk import pixbuf_new_from_file
from gsmile.shared import gglobals
from time import time


class Emoticon:


	def __init__(self, node, folder, id):
	
		node.normalize()
	
		self.ref = node
		
		self.id = id
		
		self.folder = gglobals.db.folders[folder]
		
		self.iter = None
		
		if folder != None:
		
			self.folder.emoticons.append(self.id)
						
		
			
			
			
	def get(self, field):
	
		try:
			return self.ref.getElementsByTagName(field)[0].firstChild.data.strip()
		except:
			print _("ERROR: Retriving information from a non-existing field (InvalidEmoticonField)")
			raise
		
		
		
	def show(self):
	
		self.iter = gglobals.gui.emotilist.add(self.id, \
			self.get('name'),\
			self.get_pixbuf()\
		)
			
			
			
	def set(self, field, value, storefield = -1):
	
		try:
			self.ref.getElementsByTagName(field)[0].firstChild.data = value
		except:
			print _("ERROR: Setting a non-existing field (InvalidEmoticonField)")
			raise
			
			
		if storefield > -1:
		
			gglobals.gui.folderstore[self.path][storefield] = value
			
			
			
	def get_pixbuf(self):
	
		try:	
		
			file = "%s/%s" % (gglobals.db.imgdir, self.get("file"))
			pb = pixbuf_new_from_file(file)
			return pb
			
		except:
		
			return None
			
			
			
	def update_counter(self):

		count = int(self.get("used")) + 1 
		self.set("used", str(count))
		self.set("last_used", str(int(time())))
		

		
