#
# gSmile - emoticon manager
# 
# Copyright (C) 2005, Federico Pelloni <federico.pelloni@gmail.com>
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

#
# NOTE: some of this code was stolen from Straw sources
# Straw home page: http://www.nongnu.org/straw/
#

import pytrayicon
import pygtk
pygtk.require('2.0')
import gtk
from gsmile.shared import gglobals
from os.path import join

class Tray:

	def __init__(self):
    
		self.tray = pytrayicon.TrayIcon(gglobals.name);

		self.eb = gtk.EventBox()

		self.tray.add(self.eb)

		image = gtk.Image()

		pixbuf = gtk.gdk.pixbuf_new_from_file(join(gglobals.pixmapdir, gglobals.icon))

		scaled_buf = pixbuf.scale_simple(16,16,gtk.gdk.INTERP_BILINEAR)

		image.set_from_pixbuf(scaled_buf)

		self.eb.add(image)
		
		self.tray.show_all()

		self._mw = gglobals.gui.mainwindow.window

		gglobals.trayicon = self

		self._create_menu()
		self._set_callbacks()



	def _set_callbacks(self):
		
		self.eb.connect("button-press-event", self._button_press_cb)
		self.eb.connect("enter-notify-event", lambda w, e: self._show_window(e))



	def _button_press_cb(self, w, event):

		if event.button == 1:

			self.switch_window(event)

		elif event.button == 3:

			self.menu.popup(None, None, None, event.button, event.time)




	def switch_window(self, event):

		if self._mw.get_property("visible") and self._mw.is_active():

			self._mw.hide()
	
		else:

			self._show_window(event)



	def _show_window(self, event):

		if gglobals.flags["windowmode"] == "advanced":

			x, y = event.get_root_coords()
				
			self._mw.move(int(x), int(y))
				
			gglobals.preferences.set("advanced", "x", int(x))
			gglobals.preferences.set("advanced", "y", int(y))


		self._mw.show()
		self._mw.present()



	def _create_menu(self):

		self.menu = gglobals.gui.mainglade.get_widget("traymenu")

		self._mi_show = gglobals.gui.mainglade.get_widget("tm_show")
		self._mi_exit = gglobals.gui.mainglade.get_widget("tm_exit")

		self._mi_show.connect("activate", self.switch_window)
		self._mi_exit.connect("activate", lambda w: quit_program())



