#
# gSmile - emoticon manager
# 
# Copyright (C) 2005, Federico Pelloni <federico.pelloni@gmail.com>
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#


from gsmile.shared import gglobals,quit_program
from os.path import expanduser, isfile
from ConfigParser import SafeConfigParser



class Preferences(SafeConfigParser):

	
	def __init__(self):
	
		gglobals.preferences = self
		
		self.gsmiledefaults = {
			"window": {
				"behaviour"	: "classic"
			},
			"classic": {
				"left_image"	: "false"
			},
			"advanced": {
				"autoshow"		: "false",
				"autohide"		: "true",
				"left_image"	: "true",
				"window_border"	: "false",
				"skip_taskbar"	: "false",
				"skip_pager"	: "true",
				"x"				: 0,
				"y"				: 0
			},
			"tagmodes": {
				"1"	: '[img]{URL}[/img] ',
				"2"	: '<img src="{URL}" alt="" />',
				"3" : '{URL} ',
				"4" : '[image]{URL}[/image] '
			}		
		}
	
		
		self._file = expanduser(gglobals.config_file)
		
		SafeConfigParser.__init__(self)
		
		self.load()
		
	
			
	def load(self):
		
		if not isfile(self._file):
			self.build()
	
		try:
			self.read(self._file)
			
		except:
			self.build()
			self.load()
	


	def build(self):
	
		print _("Notice: Creating configuration file")
		
		for section, content in self.gsmiledefaults.iteritems():
		
			self.add_section(section)
			
			for key, value in content.iteritems():
			
				self.set(section, key, value)
	

		try:
			f = file(self._file, 'wb')
			self.write(f)
			f.close()
			
		except:
			print _("ERROR: Unable to write configuration file.\n"\
					"Maybe wrong permissions?")
			quit_program(1)
			
			
			
	def close(self):
	
		try:
			f = file(self._file, 'wb')
			self.write(f)
			f.close()
			
		except:
			print _("ERROR: Unable to write configuration file.\n"\
					"Maybe wrong permissions?")
		
		return
			
		
