#
# gSmile - emoticon manager
# 
# Copyright (C) 2005, Federico Pelloni <federico.pelloni@gmail.com>
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#


from gsmile.shared import gglobals
from gtk import ListStore
from gobject import TYPE_INT, TYPE_STRING
from string import replace


class TagModes:
	"""Tagmodes management class"""  
	
	def __init__(self):
		"""Init the tagmodes management class"""
		
		self.store = ListStore(TYPE_INT, TYPE_STRING)
		
		gglobals.tagmodes = self
		
		self.current = None
		
		self._pref = gglobals.preferences
		
		self.load()
	
		

		
	def load(self):
		
		l = self._pref.items("tagmodes")
		
		for id, tm in l:
		
			self.store.append((int(id), tm))
			 
			 
			 
			 
	def cb_changed_tagmode(self, w):
	
		try:
			c = w.child.get_text()
		except:
			c = "[img]{URL}[/img]"
		
		self.current = replace(c, "{URL}", '%s')
			 
		
		
